void PremierLancement(){
      
    Serial.println("1er lancement");
    //on regarde si serial2 est la
    Envoie1Info(74); //J
    delay(200);
    LectureTor4();
    delay(200);
    premierLancement  = false;
}



void Envoie1Info(int command) {

  // 72 = H
  // 73 = I
  // 74 = J
  // 74 = K
  // 76 = L
  // 77 = M
  // 78 = N
  // 79 = O
  //   = P
  


  digitalWrite(led_Tx, HIGH);
  Serial.println("Debut envoie vers tor4,1 valeurs");
  toR4.write(command);
  toR4.println();
  Serial.println("Fin envoie vers tor4 de 1 valeurs");
}

void Envoie2Info(int command, int val_01) {
  // 73 = I
  // 76 = L
  digitalWrite(led_Tx, HIGH);
  Serial.println("Debut envoie vers tor4, 2 valeurs");
  toR4.write(command);
  toR4.print(",");
  toR4.println(val_01);
  Serial.println("Fin envoie vers tor4 de 2 valeurs");
}

void Envoie3Info(int command, int val_01, int val_02) {
  // 73 = I
  // 76 = L
  digitalWrite(led_Tx, HIGH);
  Serial.println("Debut envoie vers tor4, 3 valeurs");
  toR4.write(command);
  toR4.print(",");
  toR4.print(val_01);
  toR4.print(",");
  toR4.println(val_02);
  Serial.println("Fin envoie vers tor4 de 3 valeurs");
}

void mouvement() {
  L_R     = 0;
  AV_AR   = 0;
  digitalWrite(RELAI_G, LOW);
  digitalWrite(RELAI_D, LOW);

  X_pos = analogRead(X_pin);
  Y_pos = analogRead(Y_pin);
  X_val = 0;
  Y_val = 0;

  if (X_pos > Center + DeadZone) {
    L_R = 1;
    X_val = map(X_pos, Center + DeadZone, 1023, 0, 255);
    //digitalWrite(RELAI_D,HIGH);
  }

  if (X_pos < Center - DeadZone) {
    L_R = -1;
    X_val = map(X_pos, Center - DeadZone, 0, 0, 255);
    //digitalWrite(RELAI_G,HIGH);
  }

  if (Y_pos > Center + DeadZone) {
    AV_AR = 1;
    Y_val = map(Y_pos, Center + DeadZone, 1023, 0, 255);
    digitalWrite(RELAI_D, LOW);
    digitalWrite(RELAI_G, LOW);
  }

  if (Y_pos < Center - DeadZone) {
    AV_AR = -1;
    Y_val = map(Y_pos, Center - DeadZone, 0, 0, 255);
    digitalWrite(RELAI_G, HIGH);
    digitalWrite(RELAI_D, HIGH);
  }

  if ((AV_AR != 0) & (L_R != 0)) {

    if (L_R == 1) {
      Serial.print(" Mouvement Circulaire Droite| ");
      Val_G_Moteur  = Y_val;
      Val_D_Moteur  = X_val;// - (X_val * (X_val / 127));
    }

    if (L_R == -1) {
      Serial.print(" Mouvement Circulaire Gauche| ");
      Val_G_Moteur  = X_val;// - (X_val * (X_val / 127));
      Val_D_Moteur  = Y_val;
    }

    Serial.print(Val_G_Moteur);
    Serial.print(" | ");
    Serial.print(Val_D_Moteur);
    Pivotement = false;
  } else {
    if ((AV_AR == 0) & (L_R == 0)) {
      Y_val = 0;
      X_val = 0;
      Val_G_Moteur  = Y_val;
      Val_D_Moteur  = Y_val;
      digitalWrite(RELAI_G, LOW);
      digitalWrite(RELAI_D, LOW);
      Pivotement = false;
      //Serial.print(" Arret | ");
    }
    if ((AV_AR == 0) & (L_R != 0)) {
      Serial.print(" Pivotement | ");
      Pivotement = true;
      Val_G_Moteur  = X_val / 1.5;
      Val_D_Moteur  = X_val / 1.5;

      if (L_R == 1) {
        Serial.print(" droite | ");
        digitalWrite(RELAI_D, HIGH);
        digitalWrite(RELAI_G, LOW);
      }

      if (L_R == -1) {
        Serial.print(" gauche | ");
        digitalWrite(RELAI_D, LOW);
        digitalWrite(RELAI_G, HIGH);
      }

      Serial.print(Val_G_Moteur);
      Serial.print(" | ");
      Serial.println(Val_D_Moteur);

    } else {
      if ((AV_AR != 0)) {
        if (AV_AR == 1) {
          Serial.print(" Mouvement Avant | ");

        }
        if (AV_AR == -1) {
          Serial.print(" Mouvement Arriere | ");
          //   Envoie3Info(73, analogRead(X_pin), analogRead(Y_pin));;
        }

        Val_G_Moteur  = Y_val;
        Val_D_Moteur  = Y_val;
        Serial.print(Val_G_Moteur);
        Serial.print(" | ");
        Serial.println(Val_D_Moteur);
        Pivotement    = false;
      }
    }
  }
  analogWrite(MOTEUR_G, Val_G_Moteur/2);
  analogWrite(MOTEUR_D, Val_D_Moteur/2);

}
