//https://wokwi.com/projects/387836581892148225

//Overchair_V14.ino
// OverChair


#include <SoftwareSerial.h>
#include <EEPROM.h>
SoftwareSerial toR4(4, 5);

const int       led_Memoire     = 6;
const int       led_Rx          = 7;
const int       led_Tx          = 8;
const int       MOTEUR_D        = 9;
const int       RELAI_D         = 10; // Taster-Pin
const int       RELAI_G         = 12; // Taster-Pin
const int       MOTEUR_G        = 11;

const int       X_pin           = A1; // X-Ausgang
const int       Y_pin           = A0; // Y-Ausgang

bool            Pivotement = false;

int             X_pos;
int             Y_pos;
int             X_val;
int             Y_val;
int             Val_G_Moteur;
int             Val_D_Moteur;

const int       DeadZone        = 100; // Y-Ausgang
const int       Center          = 512;
int             L_R             = 0;
int             AV_AR           = 0;
int             x;

long            h_debut_led_Tx ;
long            h_debut_led_Rx ;
long            h_debut_reception;
long            h_debut_Allume_Led_Memoire;
long            h_debut_Allume_Led;
long            h_relative;
int             d_pause_led_Tx_Rx   = 50;
int             d_pause_led_Memoire = 200;

boolean         inverse         = false;
int             diRection       = 0;

int             ecran_selected  = 0;  // ecran selectionné = aucun
int             ligne_selected  = 0;  // ligne selectionné = aucun

volatile  int   pwmVal          = 0;  // de 0 à 255
volatile  int   dir             = 0;
volatile  int   spdVal          = 0;
boolean         etatLed;        // HIGH / LOW

static  int     pos             = 0;
int             newPos;


int             val01;
int             val02;
int             val03;
int             val04;

int             val_An_01;
int             val_An_02;
int             val_An_03;
int             val_An_04;

int             memoVal01       = 0;
int             memoVal02       = 0;
int             memoVal03       = 0;
int             memoVal04       = 0;

volatile  boolean flag_clignote = false;  // to blink

char            user_text[20];    // pointeur de type char pour varier les textes
char            Retour[]        = "Press to go back";
char            Rotate[]        = "Rotate to Change";

int             neutreJoyX      = 0;
int             neutreJoyY      = 0;
int             limitMaxJoyGX   = 0;
int             limitMaxJoyDX   = 0;
int             limitMinJoyGX   = 0;
int             limitMinJoyDX   = 0;

int             limitMaxJoyAvY  = 0;
int             limitMaxJoyArY  = 0;
int             limitMinJoyAvY  = 0;
int             limitMinJoyArY  = 0;

int             vitMinMotAvG    = 0;
int             vitMinMotAvD    = 0;
int             vitMinMotArG    = 0;
int             vitMinMotArD    = 0;

int             vitMaxMotAvG    = 0;
int             vitMaxMotAvD    = 0;
int             vitMaxMotArG    = 0;
int             vitMaxMotArD    = 0;

int             vitTestMoteurG  = 0;
int             vitTestMoteurD  = 0;

int             vitMaxRotG      = 0;
int             vitMaxRotD      = 0;

int             delayAv         = 0;
int             delayAr         = 0;
int             delayInv        = 0;

boolean         inModif         = false;
boolean         possibleModif   = true;

int             courbeG         = 0;
int             courbeD         = 0;
int             courbeAV        = 0;
int             courbeAR        = 0;

int             delayPHI        = 0;
int             zonePHI         = 0;


int             incomingByte;     // variable
boolean         retour_Info     = true;
String          inputString     = "";   // chaine de caractères pour contenir les données
boolean         stringComplete  = false;  // pour savoir si la chaine est complète

bool            passage1        = true;


bool            brx             = false;
bool            btx             = false;
bool            envoiXY         = false;
bool            modeParametrage = false;
bool            esp32connected  = false;
bool            premierLancement = true;
bool            modeMoteur      = false;

void setup() {
  Serial.begin(115200);
  toR4.begin(57600);
  inputString.reserve(200);

  pinMode(led_Memoire, OUTPUT);
  pinMode(led_Tx, OUTPUT);
  pinMode(led_Rx, OUTPUT);
  pinMode(MOTEUR_G, OUTPUT);
  pinMode(MOTEUR_D, OUTPUT);
  pinMode(RELAI_G, OUTPUT);
  pinMode(RELAI_D, OUTPUT);

  digitalWrite(led_Memoire, LOW);
  Serial.println("On va lire la mémoire");
  LireMemoire();
  Serial.println("La memoire a été lu");
  premierLancement = true;
  delay(500);
}

void loop() {
  if (premierLancement) {
    PremierLancement();
  }
  LectureTor4();
  if (!modeParametrage) {
    mouvement();
  }

  if (modeMoteur) {
    if (analogRead(Y_pin) > 600 ) {
      analogWrite(MOTEUR_G, vitTestMoteurG);
      analogWrite(MOTEUR_D, vitTestMoteurD);
    }
    else {
      analogWrite(MOTEUR_G, 0);
      analogWrite(MOTEUR_D, 0);
    }
  }

  if (envoiXY) {
    Envoie3Info(73, analogRead(X_pin), analogRead(Y_pin));
  }
  delay(100);
}
