void LectureTor4() {
  if (toR4.available() > 0) {
    digitalWrite(led_Rx, HIGH);
    digitalWrite(led_Tx, LOW);
    h_debut_led_Rx = millis();
    String myString = (toR4.readStringUntil('\n'));
    myString.trim();
    inputString = myString;
    Serial.print("Recu sur toR4 : ");
    Serial.println(inputString);
    Traitement_Reception(inputString);
  }
  digitalWrite(led_Tx, LOW);
  digitalWrite(led_Rx, LOW);
}
void Traitement_Reception(String Donnees_recues) {
  char Command; // S , V , P , M ;
  int val_1;
  int val_2;
  int val_3;
  int val_4;
  int val_5;
  int val_6;
  int val_7;
  int val_8;
  int val_9;
  int val_10;
  int NbElements ;

  const char *text = Donnees_recues.c_str();

  NbElements = sscanf(text, "%c, %d, %d, %d, %d, %d, %d, %d, %d, %d", &Command, &val_1, &val_2, &val_3, &val_4, &val_5, &val_6, &val_7, &val_8, &val_9, &val_10);
  Serial.print("NbElements : ");
  Serial.println(NbElements);
  switch (NbElements) {
    case -1 :
      Serial.println("I , Mauvais -1, ");// + '\n');
      break;
    case 1 :
      switch (Command) {
        case 'H':
          Serial.println("L'esp32 est connecté par H");
          Serial.println("Mode Parametrage");
          modeParametrage   = true;
          esp32connected    = true;
          premierLancement  = false;
          Envoie1Info(72);
          break;

        case 'J':
          Serial.println("L'esp32 est connecté par J");
          modeParametrage = true;
          premierLancement  = false;
          break;
        default:
          if (retour_Info) {
            Serial.println("I , CommandM Inconnue");//, " + '\n');
          }
          break;
      }
      break;
    case 2:
      switch (Command) {
        case 'I': // envoie ou no envoie info
          Serial.print("Reçu I : ");// + '\n');
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.println(val_1);// + val_1 + '\n')
          envoiXY   = val_1; // flag pour que la boucle lise les données entrantes
          break;
        case 'P':
          Serial.println("Paramétrage en cour");
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.println(val_1);// + val_1 + '\n')
          modeParametrage = val_1;
          LireMemoire();
          break;
        case 'M':
          Serial.println("Moteur");
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.println(val_1);// + val_1 + '\n')
          modeMoteur = val_1;
          vitTestMoteurG = 0;
          vitTestMoteurD = 0;
          digitalWrite(RELAI_D, LOW);
          digitalWrite(RELAI_G, LOW);
          break;
        case 'L': // Lire l'eeprom
          Serial.print("Reçu L : ");// + '\n');
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.print(val_1);// + val_1 + '\n')
          int valeurLu;
          EEPROM.get(val_1, valeurLu);
          Serial.print(" ; Valeur LU: ");
          Serial.println(valeurLu);
          delay(200);
          Envoie3Info(76, val_1, valeurLu);
          delay(200);
          break;
        case 'S':
          Serial.print("Reçu S : ");// + '\n');
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.println(val_1);// + val_1 + '\n')
          EEPROM.get(25, valeurLu);
          Serial.print("Number: ");
          Serial.println(valeurLu);
          break;
        default:
          if (retour_Info) {
            Serial.println("I , CommandM Inconnue");//, " + '\n');
          }
          break;
      }
      break;
    case 3:
      switch (Command) {
        case 'E': // Ecrire dans l'eeprom
          Serial.print("Reçu E : ");// + '\n');
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.print(val_1);// + val_1 + '\n')
          Serial.print(" ; Val 2 : ");// + val_1 + '\n');
          Serial.println(val_2);// + val_1 + '\n')
          EEPROM.put(val_1, val_2);
          break;
        case 'A': // Moteur Gauche et Droite Avance
          Serial.print("Reçu A : ");// + '\n');
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.print(val_1);// + val_1 + '\n')
          Serial.print(" ; Val 2 : ");// + val_1 + '\n');
          Serial.println(val_2);// + val_1 + '\n')
          vitTestMoteurG    = val_1;
          vitTestMoteurD    = val_2;
          digitalWrite(RELAI_G, LOW);
          digitalWrite(RELAI_D, LOW);
          break;
        case 'R': // Moteur Gauche et Droite Recule
          Serial.print("Reçu R : ");// + '\n');
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.print(val_1);// + val_1 + '\n')
          Serial.print(" ; Val 2 : ");// + val_1 + '\n');
          Serial.println(val_2);// + val_1 + '\n')
          vitTestMoteurG    = val_1;
          vitTestMoteurD    = val_2;
          digitalWrite(RELAI_G, HIGH);
          digitalWrite(RELAI_D, HIGH);

          break;
        case 'M': // moteur tourne suivant le sens
          Serial.print("Reçu M : ");// + '\n');
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.print(val_1);// + val_1 + '\n')
          Serial.print(" ; Val 2 : ");// + val_1 + '\n');
          Serial.println(val_2);// + val_1 + '\n')
          break;
        case 'X': // moteur tourne suivant vitesse
          Serial.print("Reçu X : ");// + '\n');
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.print(val_1);// + val_1 + '\n')
          Serial.print(" ; Val 2 : ");// + val_1 + '\n');
          Serial.println(val_2);// + val_1 + '\n')
          //     vitMinMotArG    = val_1;
          //     vitMinMotArD    = val_2;
          break;
        case 'Y': // moteur tourne suivant vitesse
          Serial.print("Reçu Y : ");// + '\n');
          Serial.print("Val 1 : ");// + val_1 + '\n');
          Serial.print(val_1);// + val_1 + '\n')
          Serial.print(" ; Val 2 : ");// + val_1 + '\n');
          Serial.println(val_2);// + val_1 + '\n')
          //   vitMinMotArG    = val_1;
          //   vitMinMotArD    = val_2;
          break;
        default:
          if (retour_Info) {
            Serial.println("I , CommandM Inconnue");//, " + '\n');
          }
          break;
      }
      break;

    default:
      if (retour_Info) {
        Serial.print("I , Endehors, " + '\n');
      }
  }

  inputString     = "";
} //Fin Lecture_Conf
